package br.com.centralit.api.dao.impl;

import java.util.List;

import org.springframework.stereotype.Repository;

import br.com.centralit.api.dao.CentroResultadoDelegacaoDao;
import br.com.centralit.api.model.CentroResultadoDelegacao;
import br.com.centralit.framework.dao.arquitetura.CitGenericDAOImpl;
import br.com.centralit.framework.dao.arquitetura.SearchSeven;

import com.googlecode.genericdao.search.Search;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 30/06/2015 - 14:10:22
 * 
 * @version 1.0.0
 * 
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 * 
 */
@Repository("centroResultadoDelegacaoDao")
public class CentroResultadoDelegacaoDaoHibernate extends CitGenericDAOImpl implements CentroResultadoDelegacaoDao {

	public CentroResultadoDelegacaoDaoHibernate() {

		super(CentroResultadoDelegacao.class);
	}

	@Override
	public List<CentroResultadoDelegacao> buscaHistoricoDelegacoes(Long idCentroResultado) {

		Search search = new Search();

		search.addFilterEqual("centroResultadoResponsavelAlcada.centroResultadoResponsavel.centroResultado.id", idCentroResultado);

		return this.search(search, CentroResultadoDelegacao.class);
	}

	@Override
	public List<CentroResultadoDelegacao> buscaHistoricoDelegacoesUsuario(Long idUsuario) {

		Search search = new Search();

		search.addFilterEqual("centroResultadoResponsavelAlcada.centroResultadoResponsavel.responsavel.pessoa.usuario.id", idUsuario);

		return this.search(search, CentroResultadoDelegacao.class);
	}

	@Override
	public boolean existeDelegacaoParaDelegadoNaAlcadaENoPeriodoSeleciona(CentroResultadoDelegacao centroResultadoDelegacao) {

		SearchSeven search = new SearchSeven();

		search.addFilterEmpty("dataRevogacao");
		search.addFilterEqual("centroResultadoResponsavelAlcada.id", centroResultadoDelegacao.getCentroResultadoResponsavelAlcada().getId());
		search.addFilterEqual("delegado.id", centroResultadoDelegacao.getDelegado().getId());
		search.addFilterGreaterOrEqual("dataFimDelegacao", centroResultadoDelegacao.getDataInicioDelegacao());

		return this.searchAndCount(search).getTotalCount() > 0;
	}

}
