package br.com.centralit.api.model;

import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import br.com.centralit.api.framework.json.ViewsAlcada;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObjectAuditOrganizacao;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 18/06/2015 - 16:58:14
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Entity
public class LimiteAprovacao extends PersistentObjectAuditOrganizacao {

    /** Atributo serialVersionUID. */
    private static final long serialVersionUID = 1L;

    /** Atributo id. */
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @JsonView({ ViewsAlcada.LimiteAprovacaoView.class })
    private Long id;
    
    @JsonView({ ViewsAlcada.LimiteAprovacaoView.class })
    private String identificacao;
    
    @ManyToOne(fetch = FetchType.LAZY)
    @JsonView({ ViewsAlcada.LimiteAprovacaoView.class })
    private Dominio dominioTipoAbrangencia;
    
    @ManyToOne(fetch = FetchType.LAZY)
    @JsonView({ ViewsAlcada.LimiteAprovacaoView.class })
    private Dominio dominioTipoLimite;
    
	@OneToMany(fetch = FetchType.LAZY, mappedBy = "limiteAprovacao", cascade = CascadeType.ALL)
	@JsonView({ ViewsAlcada.LimiteAprovacaoView.class })
	private Collection<LimiteAprovacaoValor> limitesAprovacoesValores;
    
    @OneToMany(fetch = FetchType.LAZY, mappedBy = "limiteAprovacao", cascade = CascadeType.ALL, orphanRemoval = true)
    @JsonView({ ViewsAlcada.LimiteAprovacaoView.class })
    private Collection<LimiteAprovacaoNivelAutoridade> niveisAutoridades;    
    
    @OneToMany(fetch = FetchType.LAZY, mappedBy = "limiteAprovacao", cascade = CascadeType.ALL, orphanRemoval = true)
    @JsonView({ ViewsAlcada.LimiteAprovacaoView.class })
    private Collection<LimiteAprovacaoAlcada> alcadas;
    

    /**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {
	
		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id 
	 */
	public void setId(Long id) {
	
		this.id = id;
	}
    
	/**
     * Retorna o valor do atributo <code>identificacao</code>
     *
     * @return <code>String</code>
     */
    public String getIdentificacao() {

        return identificacao;
    }

    /**
     * Define o valor do atributo <code>identificacao</code>.
     *
     * @param identificacao
     */
    public void setIdentificacao(String identificacao) {

        this.identificacao = identificacao;
    }
    
	
	/**
	 * Retorna o valor do atributo <code>limitesAprovacoesValores</code>
	 *
	 * @return <code>Collection<LimiteAprovacaoValor></code>
	 */
	public Collection<LimiteAprovacaoValor> getLimitesAprovacoesValores() {
	
		return limitesAprovacoesValores;
	}

	
	/**
	 * Define o valor do atributo <code>limitesAprovacoesValores</code>.
	 *
	 * @param limitesAprovacoesValores 
	 */
	public void setLimitesAprovacoesValores(Collection<LimiteAprovacaoValor> limitesAprovacoesValores) {
	
		this.limitesAprovacoesValores = limitesAprovacoesValores;
	}

	/**
	 * Retorna o valor do atributo <code>dominioTipoAbrangencia</code>
	 *
	 * @return <code>Dominio</code>
	 */
	public Dominio getDominioTipoAbrangencia() {
	
		return dominioTipoAbrangencia;
	}

	/**
	 * Define o valor do atributo <code>dominioTipoAbrangencia</code>.
	 *
	 * @param dominioTipoAbrangencia 
	 */
	public void setDominioTipoAbrangencia(Dominio dominioTipoAbrangencia) {
	
		this.dominioTipoAbrangencia = dominioTipoAbrangencia;
	}

	/**
	 * Retorna o valor do atributo <code>dominioTipoLimite</code>
	 *
	 * @return <code>Dominio</code>
	 */
	public Dominio getDominioTipoLimite() {
	
		return dominioTipoLimite;
	}
	
	/**
	 * Define o valor do atributo <code>dominioTipoLimite</code>.
	 *
	 * @param dominioTipoLimite 
	 */
	public void setDominioTipoLimite(Dominio dominioTipoLimite) {
	
		this.dominioTipoLimite = dominioTipoLimite;
	}

	/**
	 * Retorna o valor do atributo <code>niveisAutoridades</code>
	 *
	 * @return <code>Collection<LimiteAprovacaoNivelAutoridade></code>
	 */
	public Collection<LimiteAprovacaoNivelAutoridade> getNiveisAutoridades() {
	
		return niveisAutoridades;
	}

	/**
	 * Define o valor do atributo <code>niveisAutoridades</code>.
	 *
	 * @param niveisAutoridades 
	 */
	public void setNiveisAutoridades(Collection<LimiteAprovacaoNivelAutoridade> niveisAutoridades) {
	
		this.niveisAutoridades = niveisAutoridades;
	}

	/**
	 * Retorna o valor do atributo <code>alcadas</code>
	 *
	 * @return <code>Collection<LimiteAprovacaoAlcada></code>
	 */
	public Collection<LimiteAprovacaoAlcada> getAlcadas() {
	
		return alcadas;
	}

	/**
	 * Define o valor do atributo <code>alcadas</code>.
	 *
	 * @param alcadas 
	 */
	public void setAlcadas(Collection<LimiteAprovacaoAlcada> alcadas) {
	
		this.alcadas = alcadas;
	}

	
}
