package br.com.centralit.api.model;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

import br.com.centralit.api.framework.json.ViewsAlcada;
import br.com.centralit.framework.model.arquitetura.PersistentObject;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 30/06/2015 - 13:56:03
 * 
 * @version 1.0.0
 * 
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 * 
 */
@Entity
@JsonIgnoreProperties({ "$selected", "$index" })
public class LimiteAprovacaoAlcada extends PersistentObject {

	/** Atributo serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** Atributo id. */
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@JsonView({ ViewsAlcada.LimiteAprovacaoView.class })
	private Long id;

	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	@JsonView({ ViewsAlcada.LimiteAprovacaoView.class })
	private Alcada alcada;

	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	private LimiteAprovacao limiteAprovacao;

	/**
	 * Retorna o valor do atributo <code>alcada</code>
	 * 
	 * @return <code>Alcada</code>
	 */
	public Alcada getAlcada() {

		return alcada;
	}

	/**
	 * Define o valor do atributo <code>alcada</code>.
	 * 
	 * @param alcada
	 */
	public void setAlcada(Alcada alcada) {

		this.alcada = alcada;
	}

	/**
	 * Retorna o valor do atributo <code>limiteAprovacao</code>
	 * 
	 * @return <code>LimiteAprovacao</code>
	 */
	public LimiteAprovacao getLimiteAprovacao() {

		return limiteAprovacao;
	}

	/**
	 * Define o valor do atributo <code>limiteAprovacao</code>.
	 * 
	 * @param limiteAprovacao
	 */
	public void setLimiteAprovacao(LimiteAprovacao limiteAprovacao) {

		this.limiteAprovacao = limiteAprovacao;
	}

	/**
	 * Retorna o valor do atributo <code>id</code>
	 * 
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 * 
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}
}
