package br.com.centralit.api.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Transient;

import br.com.centralit.api.framework.json.ViewsAlcada;
import br.com.centralit.framework.json.MoneyDeserializer;
import br.com.centralit.framework.model.Dominio;
import br.com.centralit.framework.model.arquitetura.PersistentObject;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonView;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 18/06/2015 - 16:57:20
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Entity
@JsonIgnoreProperties({ "$index" })
public class LimiteAprovacaoValor extends PersistentObject {

    /** Atributo serialVersionUID. */
    private static final long serialVersionUID = 1L;

    /** Atributo id. */
    @Id
	@GeneratedValue(strategy = GenerationType.AUTO)
    @JsonView({ ViewsAlcada.LimiteAprovacaoView.class })
    private Long id;
    
    @ManyToOne
    @JsonView({ ViewsAlcada.LimiteAprovacaoView.class })
    private Dominio dominioTipoLimiteValor;
    
    @ManyToOne
    @JsonView({ ViewsAlcada.LimiteAprovacaoView.class })
    private Dominio dominioTipoUtilizacao;
    
    @Column(precision = 20, scale = 2)
    @JsonDeserialize(using = MoneyDeserializer.class)
    @JsonView({ ViewsAlcada.LimiteAprovacaoView.class })
    private BigDecimal valorLimite;
    
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	private LimiteAprovacao limiteAprovacao;
	
    @Transient
	private Collection<ValorAcumulado> valoresAcumulados = new ArrayList<ValorAcumulado>();
	
     /**
     * Retorna o valor do atributo <code>dominioTipoLimiteValor</code>
     *
     * @return <code>Dominio</code>
     */
    public Dominio getDominioTipoLimiteValor() {

        return dominioTipoLimiteValor;
    }

    /**
     * Define o valor do atributo <code>dominioTipoLimiteValor</code>.
     *
     * @param dominioTipoLimiteValor
     */
    public void setDominioTipoLimiteValor(Dominio dominioTipoAbrangencia) {

        this.dominioTipoLimiteValor = dominioTipoAbrangencia;
    }
     
     /**
     * Retorna o valor do atributo <code>dominioTipoUtilizacao</code>
     *
     * @return <code>Dominio</code>
     */
    public Dominio getDominioTipoUtilizacao() {

        return dominioTipoUtilizacao;
    }

    /**
     * Define o valor do atributo <code>dominioTipoUtilizacao</code>.
     *
     * @param dominioTipoUtilizacao
     */
    public void setDominioTipoUtilizacao(Dominio dominioTipoUtilizacao) {

        this.dominioTipoUtilizacao = dominioTipoUtilizacao;
    }
     
     /**
     * Retorna o valor do atributo <code>valorLimite</code>
     *
     * @return <code>BigDecimal</code>
     */
    public BigDecimal getValorLimite() {

        return valorLimite;
    }

    /**
     * Define o valor do atributo <code>valorLimite</code>.
     *
     * @param valorLimite
     */
    public void setValorLimite(BigDecimal valorLimite) {

        this.valorLimite = valorLimite;
    }
     
     /**
	 * Retorna o valor do atributo <code>id</code>
	 *
	 * @return <code>Long</code>
	 */
	public Long getId() {

		return id;
	}

	/**
	 * Define o valor do atributo <code>id</code>.
	 *
	 * @param id
	 */
	public void setId(Long id) {

		this.id = id;
	}

	
	/**
	 * Retorna o valor do atributo <code>limiteAprovacao</code>
	 *
	 * @return <code>LimiteAprovacao</code>
	 */
	public LimiteAprovacao getLimiteAprovacao() {
	
		return limiteAprovacao;
	}

	
	/**
	 * Define o valor do atributo <code>limiteAprovacao</code>.
	 *
	 * @param limiteAprovacao 
	 */
	public void setLimiteAprovacao(LimiteAprovacao limiteAprovacao) {
	
		this.limiteAprovacao = limiteAprovacao;
	}
	
	/**
	 * Retorna o valor do atributo <code>valoresAcumulados</code>
	 *
	 * @return <code>Collection<ValorAcumulado></code>
	 */
	public Collection<ValorAcumulado> getValoresAcumulados() {
	
		return valoresAcumulados;
	}

	
	/**
	 * Define o valor do atributo <code>valoresAcumulados</code>.
	 *
	 * @param valoresAcumulados 
	 */
	public void setValoresAcumulados(Collection<ValorAcumulado> valoresAcumulados) {
	
		this.valoresAcumulados = valoresAcumulados;
	}
	
	public ValorAcumulado adicionaValorAcumulado(NivelAutoridade nivelAutoridade, Float valor) {
		ValorAcumulado valorAcumulado = null;
		for (ValorAcumulado valorAcumuladoAux : this.getValoresAcumulados()) {
			if (valorAcumuladoAux.getNivelAutoridade().getId().equals(nivelAutoridade.getId())) {
				valorAcumulado = valorAcumuladoAux;
				break;
			}
		}
		
		if (valorAcumulado == null) {
			valorAcumulado = new ValorAcumulado(nivelAutoridade);
			this.getValoresAcumulados().add(valorAcumulado);
		}
		
		valorAcumulado.setValor(valorAcumulado.getValor() + valor);
		return valorAcumulado;
	}
	

}
