package br.com.centralit.api.service;

import java.util.List;

import br.com.centralit.api.model.Alcada;
import br.com.centralit.api.model.ResponsavelAlcada;
import br.com.centralit.api.model.SolicitacaoAlcada;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.service.arquitetura.GenericService;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 18/06/2015 - 16:57:07
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.centralit@gmail.com">lucas.centralit@gmail.com</a>)
 *	
 */
public interface SolicitacaoAlcadaService extends GenericService<SolicitacaoAlcada, Long> {
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por retornar os autorizadores de uma solicitação de alçada
	 *
	 * @author Carlos
	 *
	 * @param solicitacaoAlcada
	 * @return
	 */
	public List<ResponsavelAlcada> getResponsaveis(SolicitacaoAlcada solicitacaoAlcada);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por autorizar um pedido de alçada
	 *
	 * @author Carlos
	 *
	 * @param solicitacaoAlcada
	 * @return
	 */
	public SolicitacaoAlcada aprovaSolicitacao(SolicitacaoAlcada solicitacaoAlcada, Usuario aprovador);
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por cancelar a autorização de um pedido de alçada
	 *
	 * @author Carlos
	 *
	 * @param voucher
	 */
	public SolicitacaoAlcada cancelaAprovacao(SolicitacaoAlcada solicitacaoAlcada);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por autorizar um pedido de alçada
	 *
	 * @author Carlos
	 *
	 * @param solicitacaoAlcada
	 * @return
	 */
	public SolicitacaoAlcada aprovaPeloIdentificador(SolicitacaoAlcada solicitacaoAlcada);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por recuperar uma alçada pelo identificador único
	 *
	 * @author Carlos
	 *
	 * @param solicitacaoAlcada
	 * @return
	 */
	public SolicitacaoAlcada recuperaSolicitacao(Alcada alcada, String identificadorUnico);

	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
	 *
	 * Método responsável por autorizar um pedido de alçada
	 *
	 * @author Carlos
	 *
	 * @param solicitacaoAlcada
	 * @return
	 */
	public Object cancelaAprovacaoPeloIdentificador(SolicitacaoAlcada solicitacaoAlcada);
	
}
