package br.com.centralit.api.service.impl;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.List;

import javax.sql.DataSource;

import net.sf.jasperreports.engine.JRException;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import br.com.centralit.api.service.DefaultFileService;
import br.com.centralit.api.service.DominioService;
import br.com.centralit.api.service.MenuService;
import br.com.centralit.api.service.ModuloService;
import br.com.centralit.api.service.PaginaService;
import br.com.centralit.framework.model.Menu;
import br.com.centralit.framework.model.MenuFile;
import br.com.centralit.framework.model.Pagina;
import br.com.centralit.framework.model.UtilStartup;

@SuppressWarnings("unused")
@Service("inicializarAlcadaService")
public class InicializarAlcadaServiceImpl extends UtilStartup {

	@Autowired
	private ModuloService moduloService;
	
	@Autowired
	private DataSource citDataSource;

	/** Atributo menuService. */
	@Autowired
	private MenuService menuService;

	/** Atributo dominioService. */
	@Autowired
	private DominioService dominioService;

	/** Atributo paginaService. */
	@Autowired
	private PaginaService paginaService;

	/** Atributo defaultFileService. */
	@Autowired
	private DefaultFileService defaultFileService;

	/** Atributo menuModuloAlcada. */
	private Menu menuModuloAlcada;

	static final Logger LOG = Logger.getLogger(InicializarAlcadaServiceImpl.class);

	public void gerarCarga() {
		criarPaginasMenus();
		this.menuService.adicionarGrupoMasterMenu(menuModuloAlcada);
	}
	
	/**
	 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
	 *
	 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>
	 *
	 *  Método responsável por criar paginas e menus do modulo
	 *
	 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
	 *
	 */
	private void criarPaginasMenus() {

		dominioJS = this.dominioService.findByChaveAndNome(TIPO_FILE, TIPO_FILE_JS);
		moduloSelecionado = this.moduloService.getModuloPorBaseUrl(BASE_URL_ALCADA, null);

		// Menu pai Alçadas
		this.menuModuloAlcada = new Menu("Alçadas", null, null, null, 6, COR_ALCADA, CSS_MENU_ALCADA, OPACIDADE_MENU_ALCADA, CLASSE_ALCADA, ICONE_MENU_ALCADA, moduloSelecionado);
		this.menuModuloAlcada = this.menuService.mergeIfNotExist(this.menuModuloAlcada);

		// Submenu Cadastros
		Menu menuCadastros = new Menu("Cadastros", null, menuModuloAlcada, 0, 1, null, null, null, null, moduloSelecionado);
		menuCadastros = this.menuService.mergeIfNotExist(menuCadastros);

		Pagina pgAlcada = new Pagina("Alçada", "/cit-alcada-web/html/alcada/alcada.html");
		pgAlcada = this.paginaService.saveIfNotExist(pgAlcada);
		Menu menuAlcada = new Menu("Alçada", pgAlcada, menuCadastros, null, 2, null, null, null, null, moduloSelecionado);
		menuAlcada.setIncludes(this.gerarArquivosMenu(menuAlcada, CIT_ALCADA_WEB_ANGULAR_CUSTOM, "Alcada", true, true, true));
		this.menuService.mergeIfNotExist(menuAlcada);
		// Menu Alçada
		Pagina pgCentroResultado = new Pagina("Centro de resultado", "/cit-alcada-web/html/centroResultado/centroResultado.html");
		pgCentroResultado = this.paginaService.saveIfNotExist(pgCentroResultado);
		Menu menuCentroResultado = new Menu("Centro de resultado", pgCentroResultado, menuCadastros, null, 3, null, null, null, null, moduloSelecionado);
		List<MenuFile> filesMenuFileCentroResultado = this.gerarArquivosMenu(menuCentroResultado, CIT_ALCADA_WEB_ANGULAR_CUSTOM, "CentroResultado", true, true, true);
		filesMenuFileCentroResultado.addAll(this.gerarArquivosMenu(menuCentroResultado, CIT_ALCADA_WEB_ANGULAR_CUSTOM, "CentroResultadoAlcadaResponsavel", true, true, true));
		filesMenuFileCentroResultado.add(new MenuFile(CIT_ALCADA_WEB_ANGULAR_CUSTOM + "repository/CentroResultadoResponsavelRepository.js", this.dominioJS, menuCentroResultado));
		filesMenuFileCentroResultado.add(new MenuFile(CIT_ALCADA_WEB_ANGULAR_CUSTOM + "repository/CentroResultadoResponsavelRepository.min.js", this.dominioJS, menuCentroResultado));
		menuCentroResultado.setIncludes(filesMenuFileCentroResultado);
		this.menuService.mergeIfNotExist(menuCentroResultado);
		// Menu Alçada
		Pagina pgLimiteAprovacao = new Pagina("Limite de aprovação", "/cit-alcada-web/html/limiteAprovacao/limiteAprovacao.html");
		pgLimiteAprovacao = this.paginaService.saveIfNotExist(pgLimiteAprovacao);
		Menu menuLimiteAprovacao = new Menu("Limite de aprovação", pgLimiteAprovacao, menuCadastros, null, 4, null, null, null, null, moduloSelecionado);
		menuLimiteAprovacao.setIncludes(this.gerarArquivosMenu(menuLimiteAprovacao, CIT_ALCADA_WEB_ANGULAR_CUSTOM, "LimiteAprovacao", true, true, true));
		this.menuService.mergeIfNotExist(menuLimiteAprovacao);

		// Submenu Delegação
		Menu menuDelegacao = new Menu("Delegação", null, menuModuloAlcada, 0, 2, null, null, null, null, moduloSelecionado);
		menuDelegacao = this.menuService.mergeIfNotExist(menuDelegacao);
		// Menu Delegação de alçada
		Pagina pgCentroResultadoDelegacao = new Pagina("Delegação por Centro de Resultado", "/cit-alcada-web/html/centroResultadoDelegacao/centroResultadoDelegacao.html");
		pgCentroResultadoDelegacao = this.paginaService.saveIfNotExist(pgCentroResultadoDelegacao);
		Menu menuCentroResultadoDelegacao = new Menu("Delegação por Centro de Resultado", pgCentroResultadoDelegacao, menuDelegacao, null, 1, null, null, null, null, moduloSelecionado);
		List<MenuFile> filesMenuFileCentroResultadoDelegacao = this.gerarArquivosMenu(menuCentroResultadoDelegacao, CIT_ALCADA_WEB_ANGULAR_CUSTOM, "CentroResultadoDelegacao", true, false, true);
		filesMenuFileCentroResultadoDelegacao.add(new MenuFile(CIT_ALCADA_WEB_ANGULAR_CUSTOM + "repository/CentroResultadoResponsavelAlcadaRepository.js", this.dominioJS, menuCentroResultadoDelegacao));
		filesMenuFileCentroResultadoDelegacao.add(new MenuFile(CIT_ALCADA_WEB_ANGULAR_CUSTOM + "repository/CentroResultadoResponsavelAlcadaRepository.min.js", this.dominioJS, menuCentroResultadoDelegacao));
		filesMenuFileCentroResultadoDelegacao.add(new MenuFile(CIT_ALCADA_WEB_ANGULAR_CUSTOM + "repository/SolicitacaoAlcadaRepository.js", this.dominioJS, menuCentroResultadoDelegacao));
		filesMenuFileCentroResultadoDelegacao.add(new MenuFile(CIT_ALCADA_WEB_ANGULAR_CUSTOM + "repository/SolicitacaoAlcadaRepository.min.js", this.dominioJS, menuCentroResultadoDelegacao));
		menuCentroResultadoDelegacao.setIncludes(filesMenuFileCentroResultadoDelegacao);
		this.menuService.mergeIfNotExist(menuCentroResultadoDelegacao);

		// Menu Delegação de alçada pelo Responsável
		Pagina pgCentroResultadoDelegacaoResponsavel = new Pagina("Delegação pelo Responsável", "/cit-alcada-web/html/centroResultadoDelegacaoResponsavel/centroResultadoDelegacaoResponsavel.html");
		pgCentroResultadoDelegacaoResponsavel = this.paginaService.saveIfNotExist(pgCentroResultadoDelegacaoResponsavel);
		Menu menuCentroResultadoDelegacaoResponsavel = new Menu("Delegação pelo Responsável", pgCentroResultadoDelegacaoResponsavel, menuDelegacao, null, 2, null, null, null, null, moduloSelecionado);
		List<MenuFile> filesMenuFileCentroResultadoDelegacaoResponsavel = this.gerarArquivosMenu(menuCentroResultadoDelegacaoResponsavel, CIT_ALCADA_WEB_ANGULAR_CUSTOM, "CentroResultadoDelegacaoResponsavel", true, false, false);
		menuCentroResultadoDelegacaoResponsavel.setIncludes(filesMenuFileCentroResultadoDelegacaoResponsavel);
		this.menuService.mergeIfNotExist(menuCentroResultadoDelegacaoResponsavel);

		// Submenu Substituicao
		Menu menuSubstituicao = new Menu("Substituição", null, menuModuloAlcada, 0, 3, null, null, null, null, moduloSelecionado);
		menuSubstituicao = this.menuService.mergeIfNotExist(menuSubstituicao);

		// Menu Substituição
		Pagina pgCentroResultadoSubstituicao = new Pagina("Substituição de Responsável", "/cit-alcada-web/html/centroResultadoSubstituicao/centroResultadoSubstituicao.html");
		pgCentroResultadoSubstituicao = this.paginaService.saveIfNotExist(pgCentroResultadoSubstituicao);
		Menu menuCentroResultadoSubstituicao = new Menu("Substituição de Responsável", pgCentroResultadoSubstituicao, menuSubstituicao, null, 3, null, null, null, null, moduloSelecionado);
		List<MenuFile> filesMenuFileCentroResultadoSubstituicao = this.gerarArquivosMenu(menuCentroResultadoSubstituicao, CIT_ALCADA_WEB_ANGULAR_CUSTOM, "CentroResultadoSubstituicao", true, false, true);
		menuCentroResultadoSubstituicao.setIncludes(filesMenuFileCentroResultadoSubstituicao);
		this.menuService.mergeIfNotExist(menuCentroResultadoSubstituicao);
		Logger.getLogger(InicializarAlcadaServiceImpl.class).info("Menu executado - InicializarAlcadaServiceImpl!");
	}

	/**
	 * Método responsável por criar a view
	 *
	 * @author t.lucaseugenio
	 *
	 * @throws SQLException
	 * @throws JRException
	 * @throws IOException
	 */
	private void criarView() {

		Connection conn = null;
		Statement stmt = null;

		try {

			conn = getConnection();
			if(conn != null){
				stmt = conn.createStatement();

				StringBuilder sql = new StringBuilder();

				sql.append("CREATE VIEW vw_centroresultadoresponsavel");
				sql.append("SELECT     Alcada.identificador as alcada, cast(replace(CentroResultado.codigo,'.','') as integer) as centro_resultado, seguranca_usuario.username as usuario, CentroResultadoResponsavel.dataInativo as data_inativo, ");
				sql.append("           NivelAutoridade.nome as nivel_autoridade ");
				sql.append("FROM         CentroResultadoResponsavel INNER JOIN ");
				sql.append("                CentroResultado ON CentroResultado.id = CentroResultadoResponsavel.centroResultado_id INNER JOIN ");
				sql.append("                CentroResultadoResponsavelAlcada ON  ");
				sql.append("                CentroResultadoResponsavelAlcada.centroResultadoResponsavel_id = CentroResultadoResponsavel.id INNER JOIN ");
				sql.append("                Alcada ON Alcada.id = CentroResultadoResponsavelAlcada.alcada_id INNER JOIN ");
				sql.append("                Parceiro ON Parceiro.id = CentroResultadoResponsavel.responsavel_id INNER JOIN ");
				sql.append("                Pessoa ON Pessoa.id = Parceiro.pessoa_id INNER JOIN ");
				sql.append("                seguranca_usuario ON seguranca_usuario.id = Pessoa.usuario_id INNER JOIN ");
				sql.append("                AlcadaNivelAutoridade ON AlcadaNivelAutoridade.alcada_id = Alcada.id INNER JOIN ");
				sql.append("                NivelAutoridade ON NivelAutoridade.id = AlcadaNivelAutoridade.nivelAutoridade_id  ");
				sql.append("where NivelAutoridade.hierarquia =  ");
				sql.append("(select min(t1.hierarquia)  ");
				sql.append("from NivelAutoridade t1   ");
				sql.append("inner join AlcadaNivelAutoridade t2 on t2.nivelautoridade_id = t1.id ");
				sql.append("and t2.alcada_id = Alcada.id ");
				sql.append("inner join NivelAutoridadeGrupo t3 ON t3.nivelAutoridade_id = t1.id  ");
				sql.append("INNER JOIN GrupoUsuario t4 ON t4.usuario_id = seguranca_usuario.id AND t4.grupo_id = t3.grupo_id) ");
				sql.append("union all ");
				sql.append("SELECT     Alcada.identificador as alcada, cast(replace(CentroResultado.codigo,'.','') as integer)  as centro_resultado, seguranca_usuario.username as usuario, CentroResultadoResponsavel.dataInativo as data_inativo, ");
				sql.append("                NivelAutoridade.nome as nivel_autoridade ");
				sql.append("FROM         centroresultadodelegacao inner join  ");
				sql.append("CentroResultadoResponsavelAlcada on centroresultadodelegacao.centroResultadoResponsavelAlcada_id ");
				sql.append("= CentroResultadoResponsavelAlcada.id  ");
				sql.append("INNER JOIN CentroResultadoResponsavel on CentroResultadoResponsavel.id = CentroResultadoResponsavelAlcada.centroresultadoresponsavel_id inner join CentroResultado ON CentroResultado.id = CentroResultadoResponsavel.centroResultado_id INNER JOIN ");
				sql.append("                Alcada ON Alcada.id = CentroResultadoResponsavelAlcada.alcada_id INNER JOIN ");
				sql.append("                Parceiro ON Parceiro.id = centroresultadodelegacao.delegado_id INNER JOIN ");
				sql.append("                Pessoa ON Pessoa.id = Parceiro.pessoa_id INNER JOIN ");
				sql.append("                seguranca_usuario ON seguranca_usuario.id = Pessoa.usuario_id INNER JOIN ");
				sql.append("                AlcadaNivelAutoridade ON AlcadaNivelAutoridade.alcada_id = Alcada.id INNER JOIN ");
				sql.append("                NivelAutoridade ON NivelAutoridade.id = AlcadaNivelAutoridade.nivelAutoridade_id ");
				sql.append("inner join                      Parceiro parc ON parc.id = centroresultadoresponsavel.responsavel_id INNER JOIN ");
				sql.append("                Pessoa pes ON pes.id = parc.pessoa_id  ");
				sql.append("where NivelAutoridade.hierarquia = ");
				sql.append("(select min(t1.hierarquia)  ");
				sql.append("from NivelAutoridade t1   ");
				sql.append("inner join AlcadaNivelAutoridade t2 on t2.nivelautoridade_id = t1.id ");
				sql.append("and t2.alcada_id = Alcada.id ");
				sql.append("inner join NivelAutoridadeGrupo t3 ON t3.nivelAutoridade_id = t1.id  ");
				sql.append("INNER JOIN GrupoUsuario t4 ON t4.usuario_id = pes.usuario_id AND t4.grupo_id = t3.grupo_id) ");

				stmt.executeUpdate(sql.toString());
			}
		} catch (Exception e) {
			throw new RuntimeException(e);
		} finally {
			closeResources(conn, stmt);

		}
	}
	/**
	 * Retorna uma conex&atilde;o
	 *
	 * */
	private Connection getConnection(){
		Connection conn = null;
		try {
			if(citDataSource != null)
				return citDataSource.getConnection();
			else
				return null;
		} catch (SQLException sqle) {
			LOG.error("N\u00e3o foi poss\u00edvel obter conex\u00e3o com o dataSource do m\u00f3dulo. Veja a exceção para identificar as causas: " + sqle.getCause());
		}
		return conn;
	}

	/**
	 * Encerra os recursos usados
	 *
	 * */
	protected void closeResources(Connection conn, Statement stmt) {
		try {
			if (conn != null){
				conn.close();
			}
			if(stmt != null){
				stmt.close();
			}
		} catch (SQLException sqle) {
			LOG.error("Não consegui encerrar os recursos de conexão ao banco de dados. Veja a exceção para identificar as causas. " + sqle.getCause());
		}
	}

}