package br.com.centralit.api.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.validation.Validator;

import br.com.centralit.api.dao.LimiteAprovacaoAlcadaDao;
import br.com.centralit.api.model.Alcada;
import br.com.centralit.api.model.LimiteAprovacao;
import br.com.centralit.api.model.LimiteAprovacaoAlcada;
import br.com.centralit.api.service.AlcadaService;
import br.com.centralit.api.service.LimiteAprovacaoAlcadaService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 23/06/2015 - 15:13:44
 * 
 * @version 1.0.0
 * 
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 * 
 */
@Service("limiteAprovacaoAlcadaService")
public class LimiteAprovacaoAlcadaServiceImpl extends GenericServiceImpl<LimiteAprovacaoAlcada, Long> implements LimiteAprovacaoAlcadaService {

	/** Atributo alcadaNivelAutoridadeService. */
	@Autowired
	private AlcadaService alcadaService;

	private LimiteAprovacaoAlcadaDao limiteAprovacaoAlcadaDao;

	@Autowired
	public LimiteAprovacaoAlcadaServiceImpl( LimiteAprovacaoAlcadaDao limiteAprovacaoAlcadaDao, @Qualifier("limiteAprovacaoAlcadaValidator") Validator validator ) {

		this.dao = limiteAprovacaoAlcadaDao;
		this.limiteAprovacaoAlcadaDao = limiteAprovacaoAlcadaDao;
		this.validator = validator;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<LimiteAprovacaoAlcada> findByAlcada(Alcada alcada) {

		return this.limiteAprovacaoAlcadaDao.findByAlcada(alcada);
	}

	/**
	 *
	 */
	@Override
	public void montarLimiteAprovacaoAlcada(LimiteAprovacao limiteAprovacao) {

		// PERCORRE A LISTA DE LIMITEAPROVACAOALCADA
		for (LimiteAprovacaoAlcada limiteAprovacaoAlcada : limiteAprovacao.getAlcadas()) {
			// CARREGA O OBJETO LIMITEAPROVACAOALCADA
			limiteAprovacaoAlcada.setAlcada(this.alcadaService.getReference(limiteAprovacaoAlcada.getAlcada().getId()));
			limiteAprovacaoAlcada.setLimiteAprovacao(limiteAprovacao);
		}
	}

}
