package br.com.centralit.api.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.validation.Validator;

import br.com.centralit.api.dao.LimiteAprovacaoNivelAutoridadeDao;
import br.com.centralit.api.model.LimiteAprovacao;
import br.com.centralit.api.model.LimiteAprovacaoNivelAutoridade;
import br.com.centralit.api.service.LimiteAprovacaoNivelAutoridadeService;
import br.com.centralit.api.service.NivelAutoridadeService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 23/06/2015 - 15:17:38
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Service("limiteAprovacaoNivelAutoridadeService")
public class LimiteAprovacaoNivelAutoridadeServiceImpl extends GenericServiceImpl<LimiteAprovacaoNivelAutoridade, Long> implements LimiteAprovacaoNivelAutoridadeService {

	/** Atributo alcadaNivelAutoridadeService. */
	@Autowired
	private NivelAutoridadeService nivelAutoridadeService;

    @Autowired
	public LimiteAprovacaoNivelAutoridadeServiceImpl(LimiteAprovacaoNivelAutoridadeDao limiteAprovacaoNivelAutoridadeDao,  @Qualifier("limiteAprovacaoNivelAutoridadeValidator") Validator validator) {
    	this.dao = limiteAprovacaoNivelAutoridadeDao;
    	this.validator = validator;
	}

	/**
	 *
	 */
	@Override
	public void montarLimiteAprovacaoNivelAutoridade(LimiteAprovacao limiteAprovacao) {

		// TODO Auto-generated method stub
		for(LimiteAprovacaoNivelAutoridade limiteAprovacaoNivelAutoridade : limiteAprovacao.getNiveisAutoridades()) {			
			// CARREGA O OBJETO LIMITEAPROVACAONIVELAUTORIDADE
			limiteAprovacaoNivelAutoridade.setNivelAutoridade(this.nivelAutoridadeService.getReference(limiteAprovacaoNivelAutoridade.getNivelAutoridade().getId()));	
			limiteAprovacaoNivelAutoridade.setLimiteAprovacao(limiteAprovacao);
		}
	}
    
}
