package br.com.centralit.api.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.validation.Validator;

import br.com.centralit.api.dao.LimiteAprovacaoDao;
import br.com.centralit.api.model.LimiteAprovacao;
import br.com.centralit.api.service.LimiteAprovacaoAlcadaService;
import br.com.centralit.api.service.LimiteAprovacaoNivelAutoridadeService;
import br.com.centralit.api.service.LimiteAprovacaoService;
import br.com.centralit.api.service.LimiteAprovacaoValorService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;
import br.com.centralit.framework.util.UtilObjeto;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 18/06/2015 - 16:57:34
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Service("limiteAprovacaoService")
public class LimiteAprovacaoServiceImpl extends GenericServiceImpl<LimiteAprovacao, Long> implements LimiteAprovacaoService {

	/** Atributo alcadaNivelAutoridadeService. */
	@Autowired
	private LimiteAprovacaoNivelAutoridadeService limiteAprovacaoNivelAutoridadeService;
	
	/** Atributo alcadaNivelAutoridadeService. */
	@Autowired
	private LimiteAprovacaoAlcadaService limiteAprovacaoAlcadaService;
	
	/** Atributo alcadaNivelAutoridadeService. */
	@Autowired
	private LimiteAprovacaoValorService limiteAprovacaoValorService;
	
    private LimiteAprovacaoDao limiteAprovacaoDao;

    @Autowired
	public LimiteAprovacaoServiceImpl(LimiteAprovacaoDao limiteAprovacaoDao,  @Qualifier("limiteAprovacaoValidator") Validator validator) {
    	this.dao = limiteAprovacaoDao;
        this.limiteAprovacaoDao = limiteAprovacaoDao;
    	this.validator = validator;
	}
 
    public LimiteAprovacao save(LimiteAprovacao limiteAprovacao) {
        
    	// TODO Auto-generated method stub
    	// VALIDA CAMPO OBRIGATÓRIO DA ENTIDADE
		if (UtilObjeto.isReferencia(this.validator)) {
			this.validarEntidade(limiteAprovacao, this.validator);
		}

		montaLimiteAprovacao(limiteAprovacao);
		
		// SALVA A TRANSFERÊNCIA
		LimiteAprovacao entitySaved = (LimiteAprovacao) this.limiteAprovacaoDao.save(limiteAprovacao);

		return entitySaved;
    }
    
    /**
     *
     */
    @Override
    public LimiteAprovacao merge(LimiteAprovacao limiteAprovacao) {
    
    	// TODO Auto-generated method stub
    	// VALIDA CAMPO OBRIGATÓRIO DA ENTIDADE
    	if (UtilObjeto.isReferencia(this.validator)) {
			this.validarEntidade(limiteAprovacao, this.validator);
		}

    	montaLimiteAprovacao(limiteAprovacao);

		// SALVA A TRANSFERÊNCIA
		LimiteAprovacao entitySaved = (LimiteAprovacao) this.limiteAprovacaoDao.merge(limiteAprovacao);
		
    	return entitySaved;
    }
    
    private void montaLimiteAprovacao(LimiteAprovacao limiteAprovacao){
    	// MONTA OS DADOS DO OBJETO LIMITEAPROVACAONIVELAUTORIDADE
		this.limiteAprovacaoNivelAutoridadeService.montarLimiteAprovacaoNivelAutoridade(limiteAprovacao);

		// MONTA OS DADOS DO OBJETO LIMITEAPROVACAONIVELAUTORIDADE
		this.limiteAprovacaoAlcadaService.montarLimiteAprovacaoAlcada(limiteAprovacao);
		
		// MONTA OS DADOS DO OBJETO LIMITEAPROVACAONIVELAUTORIDADE
		this.limiteAprovacaoValorService.montarLimiteAprovacaoValor(limiteAprovacao);
    }
}
