package br.com.centralit.api.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.validation.Validator;

import br.com.centralit.api.dao.LimiteAprovacaoValorDao;
import br.com.centralit.api.model.LimiteAprovacao;
import br.com.centralit.api.model.LimiteAprovacaoValor;
import br.com.centralit.api.service.LimiteAprovacaoService;
import br.com.centralit.api.service.LimiteAprovacaoValorService;
import br.com.centralit.framework.service.arquitetura.GenericServiceImpl;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 18/06/2015 - 16:57:02
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Service("limiteAprovacaoValorService")
public class LimiteAprovacaoValorServiceImpl extends GenericServiceImpl<LimiteAprovacaoValor, Long> implements LimiteAprovacaoValorService {

	/** Atributo alcadaNivelAutoridadeService. */
	@Autowired
	private LimiteAprovacaoService limiteAprovacaoService;

    @Autowired
	public LimiteAprovacaoValorServiceImpl(LimiteAprovacaoValorDao limiteAprovacaoValorDao,  @Qualifier("limiteAprovacaoValorValidator") Validator validator) {
    	this.dao = limiteAprovacaoValorDao;
    	this.validator = validator;
	}

	/**
	 *
	 */
	@Override
	public void montarLimiteAprovacaoValor(LimiteAprovacao limiteAprovacao) {

		// TODO Auto-generated method stub
		// PERCORRE A LISTA DE ALCADANIVELAUTORIDADE
		if(limiteAprovacao.getLimitesAprovacoesValores() != null){
			for(LimiteAprovacaoValor limiteAprovacaoValor : limiteAprovacao.getLimitesAprovacoesValores()) {			
				// CARREGA O OBJETO LIMITEAPROVACAOVALOR
				limiteAprovacaoValor.setLimiteAprovacao(limiteAprovacao);
			}
		}
	}
    
}
