package br.com.centralit.api.service.validation;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import br.com.centralit.api.model.SolicitacaoAlcada;
import br.com.centralit.framework.exception.CodigoErro;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 18/06/2015 - 16:56:53
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.centralit@gmail.com">lucas.centralit@gmail.com</a>)
 *	
 */
@Component("solicitacaoAlcadaValidator")
public class SolicitacaoAlcadaValidator implements Validator {

    @Override
	public boolean supports(Class<?> clazz) {

		return SolicitacaoAlcada.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {
		
        ValidationUtils.rejectIfEmpty(errors, "alcada", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "ALCADA.LABEL.ALCADA");
        
        ValidationUtils.rejectIfEmpty(errors, "centroResultado", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "ALCADA.LABEL.CENTRO_RESULTADO");
        
        ValidationUtils.rejectIfEmpty(errors, "valor", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "SOLICITACAO_ALCADA.VALOR");

        ValidationUtils.rejectIfEmpty(errors, "dataReferencia", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "SOLICITACAO_ALCADA.DATA_REFERENCIA");
        
        ValidationUtils.rejectIfEmpty(errors, "tipoUtilizacao", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "SOLICITACAO_ALCADA.TIPO_UTILIZACAO");
        
        ValidationUtils.rejectIfEmpty(errors, "identificador", CodigoErro.VALIDACAO_CAMPOS_OBRIGATORIOS.getValue().toString(), "SOLICITACAO_ALCADA.ID_ORIGEM_SOLICITACAO");
          
	}
}

