package br.com.centralit.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.framework.json.ViewsTabelasCorp;
import br.com.centralit.api.model.CentroResultadoResponsavel;
import br.com.centralit.api.service.CentroResultadoResponsavelService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 30/06/2015 - 14:08:44
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Controller
@RequestMapping("/rest/centroResultadoAlcadaResponsavel")
public class CentroResultadoAlcadaResponsavelController extends GenericController<CentroResultadoResponsavel>{

	private CentroResultadoResponsavelService centroResultadoAlcadaResponsavelService;
	
	@Autowired
	public CentroResultadoAlcadaResponsavelController(CentroResultadoResponsavelService centroResultadoAlcadaResponsavelService) {
		super(centroResultadoAlcadaResponsavelService);
		this.centroResultadoAlcadaResponsavelService = centroResultadoAlcadaResponsavelService;
	}
	
	@RequestMapping(value = "/buscaHistoricoResponsaveis", method = RequestMethod.GET)
	@ResponseBody
	public ResponseBodyWrapper buscaHistoricoResponsaveis(@RequestParam("idCentroResultado") Long idCentroResultado) {

		List<CentroResultadoResponsavel> responsaveis = centroResultadoAlcadaResponsavelService.buscaHistoricoResponsaveis(idCentroResultado);

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(responsaveis, ViewsTabelasCorp.CentroResultadoResponsavelTodosResponsaveis.class);

		return responseBody;
	}
}
