package br.com.centralit.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.framework.json.ViewsTabelasCorp;
import br.com.centralit.api.model.CentroResultadoDelegacao;
import br.com.centralit.api.service.CentroResultadoDelegacaoService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.json.Views.GenericView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 30/06/2015 - 14:10:34
 * 
 * @version 1.0.0
 * 
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 * 
 */
@Controller
@RequestMapping("/rest/centroResultadoDelegacao")
public class CentroResultadoDelegacaoController extends GenericController<CentroResultadoDelegacao> {

	private CentroResultadoDelegacaoService centroResultadoDelegacaoService;

	@Autowired
	public CentroResultadoDelegacaoController( CentroResultadoDelegacaoService centroResultadoDelegacaoService ) {

		super(centroResultadoDelegacaoService);
		this.centroResultadoDelegacaoService = centroResultadoDelegacaoService;

	}

	@RequestMapping(value = "/buscaHistoricoDelegacoes", method = RequestMethod.GET)
	@ResponseBody
	public ResponseBodyWrapper buscaHistoricoDelegacoes(@RequestParam("idCentroResultado") Long idCentroResultado) {

		List<CentroResultadoDelegacao> delegados = centroResultadoDelegacaoService.buscaHistoricoDelegacoes(idCentroResultado);

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(delegados, ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class);

		return responseBody;
	}

	@RequestMapping(value = "/buscaHistoricoDelegacoesUsuario", method = RequestMethod.GET)
	@ResponseBody
	public ResponseBodyWrapper buscaHistoricoDelegacoesUsuario(@RequestParam("idUsuario") Long idUsuario) {

		List<CentroResultadoDelegacao> delegados = centroResultadoDelegacaoService.buscaHistoricoDelegacoesUsuario(idUsuario);

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(delegados, ViewsTabelasCorp.CentroResultadoDelegacaoTodasDelegacoes.class);

		return responseBody;
	}


	@RequestMapping(value = "/revogar", method = RequestMethod.GET)
	@ResponseBody
	public ResponseBodyWrapper revogar(@RequestParam("idCentroResultadoDelegacao") Long idCentroResultadoDelegacao) {

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(centroResultadoDelegacaoService.revogar(idCentroResultadoDelegacao), getEditView());

		return responseBody;
	}

	@RequestMapping(value = "/saveList", method = RequestMethod.POST)
	@ResponseBody
	public ResponseBodyWrapper saveList(@RequestBody List<CentroResultadoDelegacao> centroResultadoDelegacaoList) {

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(centroResultadoDelegacaoService.saveList(centroResultadoDelegacaoList), getEditView());

		return responseBody;
	}

	@Override
	public Class<? extends GenericView> getEditView() {

		return ViewsTabelasCorp.CentroResultadoDelegacaoResponsavel.class;
	}
}
