package br.com.centralit.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.framework.json.ViewsTabelasCorp;
import br.com.centralit.api.model.CentroResultadoSubstituicao;
import br.com.centralit.api.service.CentroResultadoSubstituicaoService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.json.Views.GenericView;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 * 
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 * 
 * <p>
 * <b>Title: </b>
 * </p>
 * 
 * <p>
 * <b>Description: </b>
 * </p>
 * 
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 * 
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 * 
 * @since 30/06/2015 - 14:10:34
 * 
 * @version 1.0.0
 * 
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 * 
 */
@Controller
@RequestMapping("/rest/centroResultadoSubstituicao")
public class CentroResultadoSubstituicaoController extends GenericController<CentroResultadoSubstituicao> {

	private CentroResultadoSubstituicaoService centroResultadoSubstituicaoService;

	@Autowired
	public CentroResultadoSubstituicaoController( CentroResultadoSubstituicaoService centroResultadoSubstituicaoService ) {

		super(centroResultadoSubstituicaoService);
		this.centroResultadoSubstituicaoService = centroResultadoSubstituicaoService;

	}

	@RequestMapping(value = "/buscaHistoricoSubstituicoes", method = RequestMethod.GET)
	@ResponseBody
	public ResponseBodyWrapper buscaHistoricoSubstituicoes(@RequestParam("idCentroResultado") Long idCentroResultado) {
		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(centroResultadoSubstituicaoService.findPorIdCentroResultado(idCentroResultado), ViewsTabelasCorp.CentroResultadoSubstituicao.class);

		return responseBody;
	}

	@Override
	public Class<? extends GenericView> getEditView() {

		return ViewsTabelasCorp.CentroResultadoSubstituicao.class;
	}
}
