package br.com.centralit.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import br.com.centralit.api.framework.json.ViewsAlcada;
import br.com.centralit.api.framework.json.ViewsTabelasCorp;
import br.com.centralit.api.model.ResponsavelAlcada;
import br.com.centralit.api.model.SolicitacaoAlcada;
import br.com.centralit.api.service.SolicitacaoAlcadaService;
import br.com.centralit.framework.controller.GenericController;
import br.com.centralit.framework.json.ResponseBodyWrapper;
import br.com.centralit.framework.json.Views;
import br.com.centralit.framework.json.Views.GenericView;
import br.com.centralit.framework.model.Usuario;
import br.com.centralit.framework.view.ResultResponseVH;

/**
 * <p><img src="http://centralit.com.br/images/logo_central.png"></p>
 *
 * <p><b>Company: </b> Central IT - Governança Corporativa - </p>
 *
 * <p><b>Title: </b></p>
 *
 * <p><b>Description: </b></p>
 * 
 * <p><b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a></p>
 *
 * <p><b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a></p>	
 * 	
 * @since 18/06/2015 - 16:58:03
 *
 * @version 1.0.0
 *
 * @author lucas.ribeiro - (<a href="mailto:lucas.ribeiro@centralit.com.br">lucas.ribeiro@centralit.com.br</a>)
 *	
 */
@Controller
@RequestMapping("/rest/solicitacaoAlcada")
public class SolicitacaoAlcadaController extends GenericController<SolicitacaoAlcada>{

	private SolicitacaoAlcadaService solicitacaoAlcadaService;
	
	@Autowired
	public SolicitacaoAlcadaController(SolicitacaoAlcadaService solicitacaoAlcadaService) {
		super(solicitacaoAlcadaService);
		this.solicitacaoAlcadaService = solicitacaoAlcadaService;
	}
	
	@Override
	public ResponseBodyWrapper update(@RequestBody SolicitacaoAlcada objeto) {
		return null;
	}

	@Override
	public ResponseBodyWrapper removeAll(@RequestBody List<Long> ids) {
		return null;
	}
	
	@RequestMapping(value = "/recuperaPeloIdentificador", method = RequestMethod.POST)
	@ResponseBody
	public ResponseBodyWrapper recuperaPeloIdentificador(@RequestBody SolicitacaoAlcada solicitacaoAlcada) {
		return new ResponseBodyWrapper(this.solicitacaoAlcadaService.recuperaSolicitacao(solicitacaoAlcada.getAlcada(), solicitacaoAlcada.getIdentificador()), ViewsAlcada.RecuperacaoAlcadaView.class);
	}
	
	@RequestMapping(value = "/registra", method = RequestMethod.POST)
	@ResponseBody
	public ResponseBodyWrapper registra(@RequestBody List<SolicitacaoAlcada> solicitacoes) {
		for (SolicitacaoAlcada solicitacaoAlcada : solicitacoes) {
			this.solicitacaoAlcadaService.save(solicitacaoAlcada);
		}
		return new ResponseBodyWrapper(null, Views.GenericView.class);
	}

	@RequestMapping(value = "/aprova/{id}", method = RequestMethod.POST)
	@ResponseBody
	public ResponseBodyWrapper aprovaSolicitacao(@PathVariable("id") Long id, @RequestBody Usuario aprovador) {
		
		SolicitacaoAlcada solicitacaoAlcada = this.solicitacaoAlcadaService.aprovaSolicitacao(solicitacaoAlcadaService.getReference(id), aprovador);
		
		return new ResponseBodyWrapper(solicitacaoAlcada, this.getListView());
	}

	@RequestMapping(value = "/aprovaPeloIdentificador", method = RequestMethod.POST)
	@ResponseBody
	public ResponseBodyWrapper aprovaPeloIdentificador(@RequestBody SolicitacaoAlcada solicitacaoAlcada) {
		return new ResponseBodyWrapper(this.solicitacaoAlcadaService.aprovaPeloIdentificador(solicitacaoAlcada), Views.GenericView.class);
	}

	@RequestMapping(value = "/cancelaAprovacao/{id}", method = RequestMethod.POST)
	@ResponseBody
	public ResponseBodyWrapper cancelaAprovacao(@PathVariable("id") Long id) {
		
		SolicitacaoAlcada solicitacaoAlcada = this.solicitacaoAlcadaService.cancelaAprovacao(solicitacaoAlcadaService.getReference(id));
		
		return new ResponseBodyWrapper(solicitacaoAlcada, Views.GenericView.class);
	}

	@RequestMapping(value = "/cancelaAprovacaoPeloIdentificador", method = RequestMethod.POST)
	@ResponseBody
	public ResponseBodyWrapper cancelaAprovacaoPeloIdentificador(@RequestBody SolicitacaoAlcada solicitacaoAlcada) {
		
		return new ResponseBodyWrapper(this.solicitacaoAlcadaService.cancelaAprovacaoPeloIdentificador(solicitacaoAlcada), Views.GenericView.class);
	}

	@Override
	@RequestMapping(method = RequestMethod.GET, produces = "application/json")
	@ResponseBody
	public ResponseBodyWrapper getList() {

		ResultResponseVH<List<SolicitacaoAlcada>> resultResponseVH = new ResultResponseVH<List<SolicitacaoAlcada>>(solicitacaoAlcadaService.findAll());

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(resultResponseVH, this.getListView());

		return responseBody;
	}

	@RequestMapping(value = "/getResponsaveis", method = RequestMethod.POST)
	@ResponseBody
	public ResponseBodyWrapper getResponsaveis(@RequestBody SolicitacaoAlcada solicitacaoAlcada) {

		ResultResponseVH<List<ResponsavelAlcada>> resultResponseVH = new ResultResponseVH<List<ResponsavelAlcada>>(solicitacaoAlcadaService.getResponsaveis(solicitacaoAlcada));

		ResponseBodyWrapper responseBody = new ResponseBodyWrapper(resultResponseVH, this.getListView());

		return responseBody;
	}

	@Override
	public Class<? extends Views.GenericView> getEditView() {
		return ViewsTabelasCorp.SolicitacaoAlcadaView.class;
	}

	@Override
	public Class<? extends GenericView> getListView() {
		return ViewsTabelasCorp.SolicitacaoAlcadaView.class;
	}
}
