package br.com.centralit.controller;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;

import javax.sql.DataSource;

import net.sf.jasperreports.engine.JRException;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import br.com.centralit.api.service.UsuarioService;
import br.com.centralit.framework.controller.GenericController;

/**
 * <p>
 * <img src="http://centralit.com.br/images/logo_central.png">
 * </p>
 *
 * <p>
 * <b>Company: </b> Central IT - Governança Corporativa -
 * </p>
 *
 * <p>
 * <b>Title: </b>ViewCentroResultadoResponsavelController
 * </p>
 *
 * <p>
 * <b>Description: </b>
 * </p>
 *
 * <p>
 * <b>Iniciativa(s):</b> <a href="LINK_PORTAL">NUMERO_INICIATIVA</a>
 * </p>
 *
 * <p>
 * <b>Regra(s) de negócio:</b> <a href="LINK_PORTAL">NUMERO_REGRA_DE_NEGOCIO</a>
 * </p>
 *
 * @since 19/07/2015 - 16:38:31
 *
 * @version 1.0.0
 *
 * @author t.lucaseugenio
 *
 */
@SuppressWarnings("rawtypes")
@Controller
@RequestMapping("/rest/viewCentroResultadoResponsavel")
public class ViewCentroResultadoResponsavelController extends GenericController {

	/** Atributo usuarioService. */
	@Autowired
	private UsuarioService usuarioService;
	
	Logger log = Logger.getLogger(ViewCentroResultadoResponsavelController.class);
	
	@Autowired
	private DataSource citDataSource;

	/**
	 * Método responsável por criar a view
	 *
	 * @author t.lucaseugenio
	 *
	 * @throws SQLException
	 * @throws JRException
	 * @throws IOException
	 */

	public void criarView() throws SQLException, JRException, IOException {

		Connection conn = null;
		Statement stmt = null;
		
		try {

			conn = getConnection();
			if(conn != null){
				stmt = conn.createStatement();
		      
				String sql = "CREATE OR REPLACE VIEW view_centroresultadoresponsavel AS "+
						 "	 SELECT cr.codigo, "+
						 "	    su.username, "+
						 "	    na.nome, "+
						 "	    crr.datainativo "+
						 "	   FROM centroresultadoresponsavel crr "+
						 "	     JOIN centroresultado cr ON cr.id = crr.centroresultado_id "+
						 "	     JOIN pessoa p ON p.id = crr.responsavel_id "+
						 "	     JOIN seguranca_usuario su ON su.id = p.usuario_id "+
						 "	     JOIN grupousuario gu ON gu.usuario_id = su.id "+
						 "	     JOIN nivelautoridadegrupo nag ON nag.grupo_id = gu.id "+
						 "	     JOIN nivelautoridade na ON na.id = nag.nivelautoridade_id; ";

				stmt.executeUpdate(sql);
			}
		} catch (Exception e) {
			throw new RuntimeException(e);
		} finally {
			closeResources(conn, stmt);
			
		}
	}
	/**
	 * Retorna uma conex&atilde;o
	 *
	 * */
	public Connection getConnection(){
		Connection conn = null;
		try {
			if(citDataSource != null)
				return citDataSource.getConnection();
			else
				return null;
		} catch (SQLException sqle) {
			log.error("N\u00e3o foi poss\u00edvel obter conex\u00e3o com o dataSource do m\u00f3dulo. Veja a exceção para identificar as causas: " + sqle.getCause());
		}
		return conn;
	}
	
	/**
	 * Encerra os recursos usados
	 *
	 * */
	public void closeResources(Connection conn, Statement stmt) {
		try {
			if (conn != null){
				conn.close();
			}
			if(stmt != null){
				stmt.close();
			}
		} catch (SQLException sqle) {
			log.error("Não consegui encerrar os recursos de conexão ao banco de dados. Veja a exceção para identificar as causas. " + sqle.getCause());
		}
	}
	
}
