'use strict';

citApp.controller('AlcadaListController', ['$scope', 'AlcadaRepository', '$translate', '$timeout', 'DominioRepository',
                                           function AlcadaListController($scope, AlcadaRepository, $translate, $timeout, DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editAlcada").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('LABEL.NOME'), value : 'nome' } , 
                       {title : $translate.instant('ALCADA.LABEL.IDENTIFICADOR'), value : 'identificador' } , 
                       {title : $translate.instant('ALCADA.LABEL.APROVACAO_NIVEL_INFERIOR'), value : 'permiteAprovacaoNivelInferior' , filter : 'booleanSimNao'} , 
                       {title : $translate.instant('ALCADA.LABEL.DISPENSA_NOVA_APROVACAO'), value : 'percDispensaNovaAprovacao' , filter : 'percentageList' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'nome', 'identificador', 'permiteAprovacaoNivelInferior', 'percDispensaNovaAprovacao'],
        filters : [ {type : 'string', field : 'nome' } , 
                    {type : 'string', field : 'identificador' } ,  
                    {type : 'boolean', field : 'permiteAprovacaoNivelInferior' } , 
                    {type : 'money', field : 'percDispensaNovaAprovacao' }]
    };
            
    // ABRI Alcada SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var alcada = $scope.alcadaChecked;

        if(!alcada) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editAlcada').scope().getAlcada(alcada, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);