'use strict';

citApp.controller('CentroResultadoAlcadaResponsavelController', ['$scope', 'CentroResultadoAlcadaResponsavelRepository', 'AlcadaRepository', 'CentroResultadoRepository', 'ColaboradorRepository', '$translate', '$timeout',
		function CentroResultadoAlcadaResponsavelController($scope, CentroResultadoAlcadaResponsavelRepository, AlcadaRepository, CentroResultadoRepository, ColaboradorRepository, $translate, $timeout) {

    $scope.centroResultadoAlcadaResponsavel = {};

    // Limpa formulário para novo cadastro
    $scope.resetForm = function() {
        $scope.limparCentroResultadoAlcadaResponsavel();
        $scope.edit = true;
        $timeout(function(){
            $scope.centroResultadoAlcadaResponsavelForm.$submitted = false;
            $scope.centroResultadoAlcadaResponsavelForm.$setPristine();
        });
    };

    // Atualiza pagina de pesquisa
    $scope.atualizaPaginaPesquisa = function () {
        angular.element('#searchCentroResultadoAlcadaResponsavel').scope().fetchResult();
    };

    // MODAL QUE CONFIRMA REMOVER DA CIDADE
    $scope.remove = function(centroResultadoAlcadaResponsavel){
        $scope.centroResultadoAlcadaResponsavel = centroResultadoAlcadaResponsavel;
        $scope.$openModalConfirm({
            message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
            callback: function () {
                CentroResultadoAlcadaResponsavelRepository.remove($scope.centroResultadoAlcadaResponsavel).then(function() {

                    $scope.$modalConfirmInstance.dismiss('cancel');
                    $scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
                    angular.element('#searchCentroResultadoAlcadaResponsavel').scope().fetchResult();

                    $scope.resetForm();
                });
            }
        });
    };

    // SALVA O CentroResultadoAlcadaResponsavel
    $scope.saveOrUpdate = function(){
        $scope.centroResultadoAlcadaResponsavelForm.$submitted = true;

        //verifica se o formulario está valido para salvar
        if($scope.centroResultadoAlcadaResponsavelForm.$valid){

            $scope.setLoadingSalva(true);

            CentroResultadoAlcadaResponsavelRepository.save($scope.centroResultadoAlcadaResponsavel).then(function(result) {
                $scope.centroResultadoAlcadaResponsavel = result.originalElement;
                $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
                $scope.centroResultadoAlcadaResponsavelForm.$submitted = false;
            });
            $scope.setLoading(false);
        }else{
            //Mensagem de erro de campos obrigatorios não preenchidos
            $scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
        }
    };

    // Limpa o formulario preenchido
    $scope.limparCentroResultadoAlcadaResponsavel = function(){
        $scope.centroResultadoAlcadaResponsavel = {};
    };

    // Consulta entidade e mostra no formulario
    $scope.getCentroResultadoAlcadaResponsavel = function(centroResultadoAlcadaResponsavel, edit){
        $scope.setLoadingGet(true);

        CentroResultadoAlcadaResponsavelRepository.get(centroResultadoAlcadaResponsavel.id).then(function(result) {
            $scope.centroResultadoAlcadaResponsavel = result.originalElement;
            $scope.edit = edit;
            $scope.setLoading(false);
        });
    };

    // FIND AUTOCOMPLETE ALCADA
    $scope.findAutoCompleteAlcada = function(value){
        return AlcadaRepository.findAutoComplete('nome', value).then(function(result) {
            return result;
        });
    };
    
    // FIND AUTOCOMPLETE CENTRORESULTADO
    $scope.findAutoCompleteCentroResultado = function(value){
        return CentroResultadoRepository.findAutoComplete('nome', value).then(function(result) {
            return result;
        });
    };
    
    // FIND AUTOCOMPLETE RESPONSAVEL
    $scope.findAutoCompleteColaborador = function(value){
        return ColaboradorRepository.findAutoComplete('nome', value).then(function(result) {
            return result;
        });
    };

}]);
