'use strict';

citApp.controller('CentroResultadoAlcadaResponsavelListController', ['$scope', 'CentroResultadoAlcadaResponsavelRepository', '$translate', '$timeout', 'DominioRepository',
		function CentroResultadoAlcadaResponsavelListController($scope, CentroResultadoAlcadaResponsavelRepository, $translate, $timeout, DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editCentroResultadoAlcadaResponsavel").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('ALCADA.LABEL.ALCADA'), value : 'alcada.nome' } , {title : $translate.instant('LABEL.CENTRORESULTADO'), value : 'centroResultado.nome' } , {title : $translate.instant('LABEL.COLABORADOR'), value : 'colaborador.nome' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'alcada.nome', 'centroResultado.nome', 'colaborador.nome'],
        filters : [ {type : 'string', field : 'alcada.nome' } , {type : 'string', field : 'centroResultado.nome' } , {type : 'string', field : 'colaborador.nome' }]
    };
    
    // ABRI CentroResultadoAlcadaResponsavel SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var centroResultadoAlcadaResponsavel = $scope.centroResultadoAlcadaResponsavelChecked;

        if(!centroResultadoAlcadaResponsavel) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editCentroResultadoAlcadaResponsavel').scope().getCentroResultadoAlcadaResponsavel(centroResultadoAlcadaResponsavel, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);