'use strict';

citApp.controller('CentroResultadoDelegacaoListController', ['$scope', 'CentroResultadoDelegacaoRepository', '$translate', '$timeout', 'DominioRepository',
		function CentroResultadoDelegacaoListController($scope, CentroResultadoDelegacaoRepository, $translate, $timeout, DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editCentroResultadoDelegacao").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('ALCADA.LABEL.CENTRO_RESULTADO'), value : 'centroResultado.nome' } , 
                       {title : $translate.instant('LABEL.DELEGADO'), value : 'delegado.pessoa.nome' } , 
                       {title : $translate.instant('LABEL.DATA_INICIO_DELEGACAO'), value : 'dataInicioDelegacao' , filter : 'dateBR'} , 
                       {title : $translate.instant('LABEL.DATA_FIM_DELEGACAO'), value : 'dataFimDelegacao' , filter : 'dateBR'} , 
                       {title : $translate.instant('LABEL.DOMINIO'), value : 'dominioTipoAbrangenciaDelegacao.descricao' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'centroResultado.nome', 
                 'delegado.pessoa.nome',
                 'dataInicioDelegacao', 
                 'dataFimDelegacao', 
                 'dominioTipoAbrangenciaDelegacao.descricao'],
        filters : [ {type : 'string', field : 'centroResultado.nome' } , 
                    {type : 'string', field : 'delegado.pessoa.nome' } , 
                    {type : 'date', field : 'dataInicioDelegacao' } , 
                    {type : 'date', field : 'dataFimDelegacao' } , 
                    {type : 'string', field : 'dominioTipoAbrangenciaDelegacao.descricao', listaDominio : [] }]
    };
    
    DominioRepository.findAllDominio('tipoDado').then(function(result) {
        $scope.filterCriteria.filters[7].listaDominio = result;
    });
            
    // ABRI CentroResultadoDelegacao SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var centroResultadoDelegacao = $scope.centroResultadoDelegacaoChecked;

        if(!centroResultadoDelegacao) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editCentroResultadoDelegacao').scope().getCentroResultadoDelegacao(centroResultadoDelegacao, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);