'use strict';

citApp.controller('CentroResultadoListController', ['$scope', 'CentroResultadoRepository', '$translate', '$timeout', 'DominioRepository',
                                                    function CentroResultadoListController($scope, CentroResultadoRepository, $translate, $timeout, DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editCentroResultado").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('LABEL.NOME'), value : 'nome' } , 
                       {title : $translate.instant('LABEL.CODIGO'), value : 'codigo' } , 
                       {title : $translate.instant('ALCADA.LABEL.CENTRO_RESULTADO_PAI'), value : 'centroResultadoParent.nome' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'nome', 'codigo', 'centroResultadoParent.nome'],
        filters : [ {type : 'string', field : 'nome' } , 
                    {type : 'string', field : 'codigo' } , 
                    {type : 'string', field : 'centroResultadoParent.nome' }]
    };
    
    // ABRI CentroResultado SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var centroResultado = $scope.centroResultadoChecked;

        if(!centroResultado) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editCentroResultado').scope().getCentroResultado(centroResultado, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);
