'use strict';

citApp.controller('centroResultadoResponsavelController', ['$scope', 'centroResultadoResponsavelRepository', 'AlcadaRepository', 'CentroResultadoRepository', 'ColaboradorRepository', '$translate', '$timeout',
		function centroResultadoResponsavelController($scope, centroResultadoResponsavelRepository, AlcadaRepository, CentroResultadoRepository, ColaboradorRepository, $translate, $timeout) {

    $scope.centroResultadoResponsavel = {};

    // Limpa formulário para novo cadastro
    $scope.resetForm = function() {
        $scope.limparcentroResultadoResponsavel();
        $scope.edit = true;
        $timeout(function(){
            $scope.centroResultadoResponsavelForm.$submitted = false;
            $scope.centroResultadoResponsavelForm.$setPristine();
        });
    };

    // Atualiza pagina de pesquisa
    $scope.atualizaPaginaPesquisa = function () {
        angular.element('#searchcentroResultadoResponsavel').scope().fetchResult();
    };

    // MODAL QUE CONFIRMA REMOVER DA CIDADE
    $scope.remove = function(centroResultadoResponsavel){
        $scope.centroResultadoResponsavel = centroResultadoResponsavel;
        $scope.$openModalConfirm({
            message: $translate.instant('MSG.CONFIRMA_EXCLUSAO'),
            callback: function () {
                centroResultadoResponsavelRepository.remove($scope.centroResultadoResponsavel).then(function() {

                    $scope.$modalConfirmInstance.dismiss('cancel');
                    $scope.showAlert("success", $translate.instant('MSG.REGISTRO_EXCLUIDO'));
                    angular.element('#searchcentroResultadoResponsavel').scope().fetchResult();

                    $scope.resetForm();
                });
            }
        });
    };

    // SALVA O centroResultadoResponsavel
    $scope.saveOrUpdate = function(){
        $scope.centroResultadoResponsavelForm.$submitted = true;

        //verifica se o formulario está valido para salvar
        if($scope.centroResultadoResponsavelForm.$valid){

            $scope.setLoadingSalva(true);

            centroResultadoResponsavelRepository.save($scope.centroResultadoResponsavel).then(function(result) {
                $scope.centroResultadoResponsavel = result.originalElement;
                $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));
                $scope.centroResultadoResponsavelForm.$submitted = false;
            });
            $scope.setLoading(false);
        }else{
            //Mensagem de erro de campos obrigatorios não preenchidos
            $scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'), " ", false);
        }
    };

    // Limpa o formulario preenchido
    $scope.limparcentroResultadoResponsavel = function(){
        $scope.centroResultadoResponsavel = {};
    };

    // Consulta entidade e mostra no formulario
    $scope.getcentroResultadoResponsavel = function(centroResultadoResponsavel, edit){
        $scope.setLoadingGet(true);

        centroResultadoResponsavelRepository.get(centroResultadoResponsavel.id).then(function(result) {
            $scope.centroResultadoResponsavel = result.originalElement;
            $scope.edit = edit;
            $scope.setLoading(false);
        });
    };

    // FIND AUTOCOMPLETE ALCADA
    $scope.findAutoCompleteAlcada = function(value){
        return AlcadaRepository.findAutoComplete('nome', value).then(function(result) {
            return result;
        });
    };
    
    // FIND AUTOCOMPLETE CENTRORESULTADO
    $scope.findAutoCompleteCentroResultado = function(value){
        return CentroResultadoRepository.findAutoComplete('nome', value).then(function(result) {
            return result;
        });
    };
    
    // FIND AUTOCOMPLETE RESPONSAVEL
    $scope.findAutoCompleteColaborador = function(value){
        return ColaboradorRepository.findAutoComplete('nome', value).then(function(result) {
            return result;
        });
    };

}]);