'use strict';

citApp.controller('CentroResultadoSubstituicaoController', ["$scope", "CentroResultadoSubstituicaoRepository", 
                                                            "PessoaRepository", "CentroResultadoRepository", "CentroResultadoResponsavelRepository", "$translate", "$timeout", "$filter", 
              function CentroResultadoSubstituicaoController($scope, CentroResultadoSubstituicaoRepository, 
            		  										PessoaRepository, CentroResultadoRepository, CentroResultadoResponsavelRepository, $translate, $timeout, $filter) {

	$scope.responsavelChecked = {};
    $scope.centroResultadoSubstituicao = {};
    $scope.historicoSubstituicoes = [];
    
    // Limpa formulário para novo cadastro
    $scope.resetForm = function() {
        $scope.filter.centroResultado = null;
        $scope.historicoSubstituicoes = [];
        $scope.limparCentroResultadoSubstituicao();
        $scope.edit = true;
        $timeout(function(){
            $scope.centroResultadoForm.$submitted = false;
            $scope.centroResultadoSubstituicaoForm.$setPristine();
        });
    };
    
    // Limpa o formulario preenchido
    $scope.limpar = function(){
        $scope.centroResultado = {};
        $scope.resetForm();
    };

    //FIND AUTOCOMPLETE CENTRORESULTADO
    $scope.findAutoCompleteCentroResultado = function(value){
        return CentroResultadoRepository.findAutoComplete('nome', value).then(function(result) {
            return result;
        });
    };
    
    //FIND AUTOCOMPELTE RESPONSAVEL
    $scope.findAutoCompleteColaborador = function(value){
        return PessoaRepository.findColaboradorPorNome(value).then(function(result) {
            return result;
        });
    };
        
    // Consulta entidade e mostra no formulario
    $scope.fetchResult = function(){
		 if($scope.filter.centroResultado && $scope.filter.centroResultado.id){
	        $scope.setLoadingGet(true);
	        $scope.limparCentroResultadoSubstituicao();
	        
	        CentroResultadoRepository.get($scope.filter.centroResultado.id).then(function(result) {
	            $scope.centroResultado = result.originalElement;
	            $scope.buscaHistoricoSubstituicoes($scope.centroResultado.id);
	            $scope.setLoading(false);            
	        });
		 }
    };
    //#### FIM METODOS TABELA ALCADAS PAGINADA ####//
    
    //#### INICIO METODOS SUBSTITUICAO ####//
    
    $scope.iniciaModal = function(){
    	$scope.limparCentroResultadoSubstituicao();
		$scope.$openModal('/cit-alcada-web/html/centroResultadoSubstituicao/dialogCentroResultadoSubstituicao.html', 'lg');
    };

    //SUBSTITUI UMA ALCADA - RESPONSAVEL
    $scope.substituir = function(formSubstituicao) {    	
    	formSubstituicao.$submitted = true;

		if(formSubstituicao.$valid){
			for (var i = 0; i < $scope.centroResultado.responsaveis.length; i++) {
				var centroResultadoResponsavel = $scope.centroResultado.responsaveis[i];
				if (centroResultadoResponsavel.responsavel.id == $scope.centroResultadoSubstituicao.substituto.id) {
					$scope.showAlert('error', $translate.instant('ALCADA.MSG.SUBSTITUTO_NAO_PERMITIDO'));
					return;
				}
			}
			
			$scope.centroResultadoSubstituicao.centroResultadoResponsavel = $scope.responsavelChecked;
			
        	$scope.setLoadingSalva(true);

        	CentroResultadoSubstituicaoRepository.save($scope.centroResultadoSubstituicao).then(function(result) {
                $scope.showAlert("success", $translate.instant('MSG.REGISTRO_SALVO'));                
    			$scope.$modalInstance.dismiss('cancel');
    			$scope.setLoading(false);
    			
    			$scope.fetchResult();
            });

		}else{
			$scope.showAlert('error', $translate.instant('VALIDACAO.ALERTA_OBRIGATORIOS'));
		}
	};
	
	$scope.limparCentroResultadoSubstituicao = function(){
		$scope.centroResultadoSubstituicao = {};
	};
	
    //#### FIM METODOS SUBSTITUICAO####//
    
    //BUSCA TODAS AS Substituicoes DO CENTRO DE RESULTADO
    $scope.buscaHistoricoSubstituicoes = function(centroResultadoId){    	
		CentroResultadoSubstituicaoRepository.buscaHistoricoSubstituicoes(centroResultadoId).then(function(result) {
		    $scope.historicoSubstituicoes  = result;            
	    });
	};
	
}]);
