'use strict';

citApp.controller('LimiteAprovacaoListController', ['$scope', 'LimiteAprovacaoRepository', '$translate', '$timeout', 'DominioRepository', 
		function LimiteAprovacaoListController($scope, LimiteAprovacaoRepository, $translate, $timeout, DominioRepository) {
    $scope.$showAdvancedFilters = false;

    $scope.resetForm = function() {
        angular.element("#editLimiteAprovacao").scope().resetForm();
    };

    $scope.headers = [ {title : $translate.instant('LABEL.IDENTIFICACAO'), value : 'identificacao' } , 
                       {title : $translate.instant('ALCADA.LABEL.TIPO_ABRANGENCIA'), value : 'dominioTipoAbrangencia.descricao' } , 
                       {title : $translate.instant('ALCADA.LABEL.TIPO_LIMITE'), value : 'dominioTipoLimite.descricao' }];

    $scope.filterCriteria = {
        start : 1,
        dir : 'asc',
        sort : 'id',
        limit : 10,
        fields: ['id', 'identificacao', 'dominioTipoAbrangencia.descricao', 'dominioTipoLimite.descricao'],
        filters : [ {type : 'string', field : 'identificacao' } , 
                    {type : 'string', field : 'dominioTipoAbrangencia.descricao', listaDominio : [] } , 
                    {type : 'string', field : 'dominioTipoLimite.descricao', listaDominio : [] }]
    };
    
    DominioRepository.findAllDominio('tipoAbrangenciaCentroResultado').then(function(result) {
        $scope.filterCriteria.filters[1].listaDominio = result;
    });
            
    DominioRepository.findAllDominio('tipoLimite').then(function(result) {
        $scope.filterCriteria.filters[2].listaDominio = result;
    });
            
    // ABRI LIMITEAPROVACAO SELECIONADA
    $scope.abrirVisualizar = function(edit){
        var limiteAprovacao = $scope.limiteAprovacaoChecked;

        if(!limiteAprovacao) {
            $scope.showAlert('warning', !edit ? $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_VISUALIZACAO') : $translate.instant('MSG.SELECIONE_UM_ITEM_PARA_EDICAO'));
            return;
        }
        angular.element('#editLimiteAprovacao').scope().getLimiteAprovacao(limiteAprovacao, edit);
        $scope.$showPageEditWorkspace($scope.workspace);
    };
}]);