'use strict';

citApp.factory('CentroResultadoDelegacaoRepository', ['RestangularAlcada', 'AbstractRepository', function (restangularAlcada, AbstractRepository) {

    function CentroResultadoDelegacaoRepository() {
    	AbstractRepository.call(this, restangularAlcada, 'rest/centroResultadoDelegacao');
    	
    	this.buscaHistoricoDelegacoes = function(value) {
    		return restangularAlcada.one(this.route + "/buscaHistoricoDelegacoes").get({idCentroResultado : value}).then();
    	};
    	
    	this.buscaHistoricoDelegacoesUsuario = function(value) {
    		return restangularAlcada.one(this.route + "/buscaHistoricoDelegacoesUsuario").get({idUsuario : value}).then();
    	};
    	
    	this.revogar = function(value) {
    		return restangularAlcada.one(this.route + "/revogar").get({idCentroResultadoDelegacao: value}).then();
    	};
    	
    	this.saveList = function(centroResultadoDelegacaoList) {
    		return restangularAlcada.all(this.route + "/saveList").post(centroResultadoDelegacaoList).then();
    	};
    }

    AbstractRepository.extend(CentroResultadoDelegacaoRepository);

    return new CentroResultadoDelegacaoRepository();
}]);
