'use strict';

citApp.factory('SolicitacaoAlcadaRepository', ['RestangularAlcada', 'AbstractRepository', function (restangularAlcada, AbstractRepository) {

    function SolicitacaoAlcadaRepository() {
        this.getResponsaveis = function (solicitacaoAlcada) {
            return this.restangular.all(this.route + '/getResponsaveis').post(solicitacaoAlcada);
        },

        this.cria = function (solicitacaoAlcada) {
            return this.restangular.all(this.route + '/cria').post(solicitacaoAlcada);
        },

        this.aprova = function (solicitacaoAlcada, usuario) {
        	return this.restangular.all(this.route + '/aprova/' + solicitacaoAlcada.id).post(usuario);
        },

        this.cancelaAprovacao = function (solicitacaoAlcada) {
            return this.restangular.all(this.route + '/cancelaAprovacao/' + solicitacaoAlcada.id).post();
        },


        AbstractRepository.call(this, restangularAlcada, 'rest/solicitacaoAlcada');
    }

    AbstractRepository.extend(SolicitacaoAlcadaRepository);

    return new SolicitacaoAlcadaRepository();
}]);
